<template>
  <div class="box-plot-chart">

    <div class="y-axis-label">
      <span>{{ chartLabels.yAxisLabel }}</span>
    </div>

    <div :class="`canvas__wrapper ${props.indicator}__wrapper q-py-sm`">
      <div :class="`containerBody_${props.indicator}`" style="height: 100% !important">
        <canvas :id="`canvas_${props.indicator}`"></canvas>
      </div>
    </div>

  </div>

  <div class="x-axis-label">
    <span>
      {{ chartLabels.xAxisLabel }}
    </span>
  </div>
</template>

<script setup>
import {
  computed,
  reactive,
  watchEffect,
  onMounted,
  onUpdated,
  toRaw,
} from 'vue';

import {
  Chart as ChartJS,
  registerables
} from 'chart.js';

import { BoxPlotController, BoxAndWiskers } from '@sgratzl/chartjs-chart-boxplot';

import getChartLabels from 'src/composables/get_chart_labels';
import getNormalizedName from 'src/composables/get_normalized_name';

ChartJS.register(...registerables);
ChartJS.register(BoxPlotController, BoxAndWiskers);

const props = defineProps({
  data:       { type: Object, required: true },
  indicator:  { type: String, required: true },
  parentSize: { required: true },
});

const localData = computed({
  get: () => toRaw(props.data).reduce((acc, item) => {
    let key = Object.keys(item);
    let value = Object.values(item)[0];
    acc[`${key}`] = value;
    return acc
  }, {}),
});

const sort = (obj) => Object.keys(obj)
  .sort()
  .reduce((acc, c) => { acc[c] = obj[c]; return acc }, {});

const makeChartConfig = () => {
  const data = sort(localData.value);
  return {
    type: 'boxplot',
    data: {
      labels: Object.keys(data).map(elem => {
        const year = elem.split(".")[0];
        const month = parseInt(elem.split(".")[1]) - 1;
        const monthName = getNormalizedName(month, 'month_short_name');
        return [monthName, year];
      }),
      datasets: [
        {
          data: Object.values(data),
          borderWidth: 1,
          borderColor: '#0066C0',
          itemRadius: 3,
          medianColor: '#0066C0',
          outlierRadius: 4,
          outlierBackgroundColor: 'lightblue',
        },
      ],
    },
    options: {
      responsive: false,
      maintainAspectRatio: false,
      elements: {
        boxandwhiskers: {
          backgroundColor: '#0066C0',
          lowerBackgroundColor: '#F26B30',
        }
      },
      scales: {
        y: {
          ticks: {
            callback: (value) => value.toLocaleString('es-EC', {style: 'currency', currency: 'USD'}),
          },
        },
      },
      plugins: {
        legend: { display: false},
        tooltip: {
          displayColors: false,
          callbacks: {
            label: (context => {
              const boxPlotValues = [
                `Mínimo: ${context.parsed.min.toLocaleString('es-EC', {style: 'currency', currency: 'USD'})}`,
                `Primer cuartil (Q1): ${context.parsed.q1.toLocaleString('es-EC', {style: 'currency', currency: 'USD'})}`,
                `Mediana (Q2): ${context.parsed.median.toLocaleString('es-EC', {style: 'currency', currency: 'USD'})}`,
                `Media: ${context.parsed.mean.toLocaleString('es-EC', {style: 'currency', currency: 'USD'})}`,
                `Tercer cuartil (Q3): ${context.parsed.q3.toLocaleString('es-EC', {style: 'currency', currency: 'USD'})}`,
                `Máximo: ${context.parsed.max.toLocaleString('es-EC', {style: 'currency', currency: 'USD'})}`,
              ];
              if(context.parsed.outliers.length > 0) {
                boxPlotValues.push(`Valores atípicos: ${context.parsed.outliers.map(elem => elem.toLocaleString('es-EC', {style: 'currency', currency: 'USD'})).join(', ')}`);
              }
              return boxPlotValues;
            }),
          },
        },
      },
      layout: {
        padding: { left: 10, right: 20 },
      },
    },
  };
};

const chartLabels = getChartLabels(props.indicator);

const canvas_id = `canvas_${props.indicator}`;
const containerBodyClass = `containerBody_${props.indicator}`;

let myChart = {};

const createChart = function() {
  const ctx = document.getElementById(canvas_id);
  myChart = new ChartJS(ctx, data);
}

const resizeContainerBody = function() {
  const containerBody = document.querySelector(`.${containerBodyClass}`);
  if (containerBody) {
    if (data['data']['labels'].length > 0) {
      containerBody.style.width = `55vw`;
    }
    if (data['data']['labels'].length > 8) {
      let length = data['data']['labels'].length;
      let containerWidth = length * 85;
      containerBody.style.width = `${containerWidth}px`;
    }
  }
}

const resizeCanvasWrapper = function() {
  const canvasWrapper = document.querySelector(`.${props.indicator}__wrapper`);
  if(canvasWrapper) {
    canvasWrapper.style.width = `${props.parentSize.width * 0.95}px`;
  }
};

let data = reactive({});

watchEffect(() => {
  data = makeChartConfig();
});

onMounted(() => {
  resizeCanvasWrapper();
  createChart();
  resizeContainerBody();
});

onUpdated(() => {
  resizeCanvasWrapper();
  resizeContainerBody();
  if(document.getElementById(canvas_id)) {
    myChart.update();
    myChart.resize();
  }
});

</script>

<style lang="scss">
@use './box-plot-chart-component-stylesheet.scss';
</style>